stages:
  - prepare
  - test
  - publish

build-ci-image:
  image: docker:latest
  services: &docker-service
    - name: docker:dind
      command: ["--experimental"]
  stage: prepare
  before_script:
    - echo "$DOCKER_PASSWORD" | docker login -u "$DOCKER_USER" --password-stdin
  after_script:
    - docker logout
  script:
    - >
      docker build
      --cache-from gcharbon/faststan:ci
      -t "gcharbon/faststan:ci-$CI_COMMIT_REF_SLUG"
      -f ci/Dockerfile
      .
    - docker push "gcharbon/faststan:ci-$CI_COMMIT_REF_SLUG"

lint-code: &test-job
  image: &ci-image
    name: "gcharbon/faststan:ci-$CI_COMMIT_REF_SLUG"
    entrypoint: [""]
  stage: test
  before_script:
    - poetry install
  script:
    - invoke lint

test-code:
  <<: *test-job
  services:
    - name: nats-streaming:latest
      alias: stan
  variables:
    STAN_HOST: stan
    STAN_PORT: 4222
    STAN_CLUSTER: test-cluster
  script:
    - invoke test

publish-package: &publish-job
  image: *ci-image
  stage: publish
  script:
    - poetry publish -u "$PYPI_USER" -p "$PYPI_PASSWORD" --build
  when: manual
  artifacts:
    paths:
      - dist/

pages:
  <<: *publish-job
  before_script:
    - poetry install
  script:
    - invoke build --no-package
    - mv dist/docs/ public/
  artifacts:
    paths:
      - public/
  when: manual
